Web_mvc/urls.py
# -*- coding: utf-8 -*-
from __future__ import absolute_import, print_function, unicode_literals
import os

from cms.sitemaps import CMSSitemap
from django.conf import settings
from django.urls import include, path, re_path
from django.conf.urls.i18n import i18n_patterns
from django.contrib import admin
from django.contrib.sitemaps.views import sitemap
from django.contrib.staticfiles.urls import staticfiles_urlpatterns
from django.views.static import serve

admin.autodiscover()

urlpatterns = [
    path('sitemap\.xml', sitemap, {'sitemaps': {'cmspages': CMSSitemap}}),
    path('taggit_autosuggest/', include('taggit_autosuggest.urls')),
]

if settings.USE_I18N:
    urlpatterns += i18n_patterns(
        path('admin/', admin.site.urls),
        path('accounts/', include('allauth.urls')),
        path('dashboard/', include('dashboard.urls'))
    )
else:
    urlpatterns += [
        path('admin/', admin.site.urls),
        path('accounts/', include('allauth.urls')),
        path('dashboard/', include('dashboard.urls'))
    ]

""" if settings.DS_SETTINGS != None:
    for urlpattern in settings.DS_SETTINGS.get('urlpatterns', []):
        if urlpattern['include'].get('namespace', False):
            urlpatterns.append(re_path(urlpattern.get('url'), include(urlpattern['include'].get('module'), namespace=urlpattern['include'].get('namespace'))))
        else:
            urlpatterns.append(re_path(urlpattern.get('url'), include(urlpattern['include'].get('module'))))
 """
urlpatterns += [
        re_path(r'^', include('cms.urls'))
    ]

# This is only needed when using runserver.
if os.environ.get('DEV', False):
    urlpatterns = [
        path('media/', serve,
            {'document_root': settings.MEDIA_ROOT, 'show_indexes': True}),
        ] + staticfiles_urlpatterns() + urlpatterns

dashboard/urls.py
from __future__ import absolute_import, print_function, unicode_literals

from django.conf.urls import url
from django.contrib.admin.views.decorators import staff_member_required
from dashboard.views import DashboardMainView, Dashboard
from dashboard.models import DashboardPage


app_name = "dashboard"

urlpatterns = [
    url(r'^$', Dashboard, name="dashboard-main"),
    url(r'^(?P<slug>[\w\.@+-]+)/', staff_member_required(DashboardMainView.as_view()), name="dashboard-detail"),
]

dashboard/models.py
from django.db import models
from cms.models import PlaceholderField
from parler.models import TranslatableModel, TranslatedFields
from djangocms_icon.fields import Icon
from django.utils.translation import ugettext_lazy as _
from django.conf import settings 
from cms.plugin_base import CMSPlugin

User = settings.AUTH_USER_MODEL

# Create your models here.
class DashboardPage(TranslatableModel):
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    translations = TranslatedFields(
        name=models.CharField(max_length=38),
        slug=models.SlugField(max_length=38),
    )
    icon = Icon()
    order = models.IntegerField(verbose_name=_("Order"), default=1)
    page=PlaceholderField('dashboard_content')

class DashboardStatistics(CMSPlugin):
    pass

class DashboardAccountStatistic(CMSPlugin):
    pass

dashboard/views.py
from django.shortcuts import render, redirect, reverse
from django.views.generic import DetailView
from dashboard.models import DashboardPage
from parler.views import TranslatableSlugMixin

# Create your views here.
class BaseDashboardView(TranslatableSlugMixin, DetailView):
    model = DashboardPage

    def get_queryset(self):
        try:
            return super().get_queryset()
        except Exception as e:
            return DashboardPage.objects.filter(user=self.request.user).first()

class DashboardMainView(BaseDashboardView):
    template_name = "dashboard/default.html"
    
    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        page = DashboardPage.objects.filter(user=self.request.user).first()
        context['active_id'] = page.pk
        context['dashboard_content'] = page
        context['dashboard_sidebar'] = DashboardPage.objects.filter(user=self.request.user).all()
        return context

def Dashboard(request):
    dashboard = DashboardPage.objects.filter(user=request.user).first()
    if dashboard != None:
        url = reverse("dashboard:dashboard-detail", kwargs={'slug': dashboard.slug})
        return redirect(url)
    else:
        return render(request, "dashboard/default.html")

Web_mvc/templates/cmsplugin_filer_image/plugins/image/default.html
{% load easy_thumbnails_tags filer_tags filer_image_tags %}{% spaceless %}
{% comment %}
	You may change the image size for special cases in your project by overriding
	this template. There are a few size manipulation filters for this in
	`filer_image_tags`:

	{% if placeholder == 'my_special_sidebar' %}
		{% thumbnail instance.image opts.size|extra_padding_y:10 crop=opts.crop upscale=opts.upscale as thumbnail %}
	{% else %}
		{% thumbnail instance.image opts.size crop=opts.crop upscale=opts.upscale as thumbnail %}
	{% endif %}
	{% if link %}<a href="{{ link }}"{% if instance.target_blank %} target="_blank"{% endif %} {{ instance.link_attributes_str }}>{% endif %}<img{% if instance.alignment %} class="{{ instance.alignment }}"{% endif %} alt="{% if instance.alt %}{{ instance.alt }}{% endif %}" src="{{ thumbnail.url }}"{% if instance.caption %} title="{{ instance.caption }}"{% endif %} />{% if link %}</a>{% endif %}
{% endcomment %}

{% if link %}<a href="{{ link }}"{% if instance.target_blank %} target="_blank"{% endif %} class="filer_image_link" {{ instance.link_attributes_str }}>{% endif %}
{% if instance.image %}
	{% if instance.use_original_image %}
		<img class="filer_image{% if instance.alignment %} {{ instance.alignment }}{% endif %}{% if instance.use_autoscale %} img-responsive{% endif %}" alt="{% if instance.alt %}{{ instance.alt }}{% endif %}" src="{{ instance.image.url }}"{% if instance.width %} width="{{ instance.width }}"{% endif %}{% if instance.height %} height="{{ instance.height }}"{% endif %}{% if instance.caption %} title="{{ instance.caption }}"{% endif %} />
	{% else %}
		{% thumbnail instance.image size crop=opts.crop upscale=opts.upscale subject_location=opts.subject_location as thumbnail %}
		<img class="filer_image {% if instance.alignment %}{{ instance.alignment }}{% endif %}{% if instance.use_autoscale %} img-responsive{% endif %}" alt="{% if instance.alt %}{{ instance.alt }}{% endif %}" src="{{ thumbnail.url }}"{% if instance.width %} width="{{ instance.width }}"{% endif %}{% if instance.height %} height="{{ instance.height }}"{% endif %}{% if instance.caption %} title="{{ instance.caption }}"{% endif %} />
	{% endif %}
{% else %}
	{# just a plain link to some external image #}
	<img class="filer_image {% if instance.alignment %}{{ instance.alignment }}{% endif %}{% if instance.use_autoscale %} img-responsive{% endif %}" alt="{% if instance.alt %}{{ instance.alt }}{% endif %}" src="{{ instance.image_url }}"{% if size.0 %} width="{{ size.0 }}"{% endif %}{% if size.1 %} height="{{ size.1 }}"{% endif %}{% if instance.caption %} title="{{ instance.caption }}"{% endif %} />
{% endif %}
{% if instance.caption or instance.description %}
	<span class="filer_image_info">
		{% if instance.caption %}<span class="title">{{ instance.caption }}</span>{% endif %}
		{% if instance.description %}<span class="desc">{{ instance.description }}</span>{% endif %}
	</span>
{% endif %}
{% if link %}</a>{% endif %}

{% endspaceless %}

Web_mvc/templates/djangocms_picture/default/picture.html
{% load easy_thumbnails_tags %}

{% if picture_link %}
    <a href="{{ picture_link }}"
    {% if instance.link_target %} target="{{ instance.link_target }}"{% endif %}
    {{ instance.link_attributes_str }}>
{% endif %}

{# start render figure/figcaption #}
{% if instance.caption_text %}
    <figure>
{% endif %}
{# end render figure/figcaption #}

<img src="{% spaceless %}
    {% if instance.external_picture %}
        {{ instance.external_picture }}
    {% elif instance.use_no_cropping %}
        {{ instance.picture.url }}
    {% elif instance.picture %}
        {% thumbnail instance.picture picture_size.size crop=picture_size.crop upscale=picture_size.upscale subject_location=instance.picture.subject_location as thumbnail %}
        {{ thumbnail.url }}
    {% endif %}{% endspaceless %}"
    {% if instance.picture.default_alt_text and not instance.attributes.alt %} alt="{{ instance.picture.default_alt_text }}"{% endif %}
    {% if instance.width %} width="{{ instance.width }}"{% endif %}
    {% if instance.height %} height="{{ instance.height }}"{% endif %}
    {{ instance.attributes_str }}
>

{# start render figure/figcaption #}
{% if instance.caption_text %}
        <figcaption>{{ instance.caption_text }}</figcaption>
    </figure>
{% endif %}
{# end render figure/figcaption #}

{% if picture_link %}
    </a>
{% endif %}

{% comment %}
    # https://developer.mozilla.org/en-US/docs/Web/HTML/Element/img
    # https://developer.mozilla.org/en-US/docs/Web/HTML/Element/figure
    # https://github.com/divio/django-filer/blob/master/filer/models/imagemodels.py
    # http://easy-thumbnails.readthedocs.io/en/2.1/usage/#templates
    {{ instance.picture }}
    # Available variables:
    {{ instance.width }}
    {{ instance.height }}
    {{ instance.alignment }}
    {{ instance.caption_text }}
    {{ instance.attributes_str }}
    # picture helper
    {{ instance.get_size }} or {{ picture_size }}
    # link settings
    {{ instance.link_url }}
    {{ instance.link_page }}
    {{ instance.link_target }}
    {{ instance.link_attributes_str }}
    # link helper
    {{ instance.get_link }} or {{ picture_link }}
    # cropping settings
    {{ instance.use_automatic_scaling }}
    {{ instance.use_no_cropping }}
    {{ instance.use_crop }}
    {{ instance.use_upscale }}
    {{ instance.thumbnail_options }}
    # activate DJANGOCMS_PICTURE_NESTING to enable nested plugins:
    {% for plugin in instance.child_plugin_instances %}
        {% render_plugin plugin %}
    {% endfor %}
{% endcomment %}

Web_mvc/templates/widget/image.html
{% load admin_modify i18n %}{% if bound_field.original_value %}
{% trans "Currently:" %} <a href="{{ bound_field.original_url }}" > {{ bound_field.original_value|escape }} </a><br />
<img src="{{ bound_field.original_url }}" width="160" /><br />
{% trans "Change:" %}{% output_all bound_field.form_fields %}
{% else %} {% output_all bound_field.form_fields %} {% endif %}

dashboard/templates/dashboard/base.html
{% load cms_tags staticfiles sekizai_tags menu_tags i18n analytical %}
<!doctype html>
<html lang="{{ LANGUAGE_CODE }}">
    <head>
        {% analytical_head_top %}
        <meta charset="utf-8">
        <title>{% block title %}{% page_attribute "page_title" %} | {{ request.site.name }}{% endblock title %}</title>
        <meta name="viewport" content="width=device-width,initial-scale=1.0">
        {% render_block "meta" %}
        {% block meta %}{% endblock meta %}

        <!-- Favicons -->
        <link href="{% static 'img/favicon.png' %}" rel="icon">
        <link href="{% static 'img/apple-touch-icon.png' %}" rel="apple-touch-icon">
        <link rel="stylesheet" href="{% static 'dashboard/css/bootstrap.min.css' %}">
        <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.3.1/css/all.css" integrity="sha384-mzrmE5qonljUremFsqc01SB46JvROS7bZs3IO2EmfFsd15uHvIt+Y8vEf7N7fWAU" crossorigin="anonymous">
        <link rel="stylesheet" href="{% static 'dashboard/css/shards-dashboards.1.3.1.min.css' %}">
        <link id="load-css-0" rel="stylesheet" type="text/css" href="https://www.gstatic.com/charts/48.1/css/core/tooltip.css">
        <link id="load-css-1" rel="stylesheet" type="text/css" href="https://www.gstatic.com/charts/48.1/css/util/util.css">

        {% render_block "css" %}
        
        {% if request.toolbar %}
        <style>
            .cms-toolbar-expanded .main-sidebar {
                margin-top: 45px;
            }
        </style>
        {% endif %}

        <style>
            .asteriskField {
                display: none;
            }
        </style>
        
        {% block css %}{% endblock css %}

        {% block head %}{% endblock head %}
        {% analytical_head_bottom %}
    </head>
    <body class="{% block body_class %}{% endblock body_class %}">
        {% cms_toolbar %}
        {% analytical_body_top %}
        <div class="container-fluid">
            <div class="row">
                {% block dashboard_sidebar %}{% endblock dashboard_sidebar %}
                <main class="main-content col-lg-10 col-md-9 col-sm-12 p-0 offset-lg-2 offset-md-3">
                    {% block dashboard_navbar %}{% endblock dashboard_navbar %}
                    <div class="main-content-container container-fluid px-4" data-aos="fade">
                        <!-- Page Header -->
                        <div class="page-header row no-gutters py-4">
                            <div class="col-12 col-sm-6 text-center text-sm-left mb-4 mb-sm-0">
                                <span class="text-uppercase page-subtitle">{% block page_subtitle %}{% trans "Overview" %}{% endblock page_subtitle %}</span>
                                <h3 class="page-title">{% block page_title %}{% trans "Dashboard" %}{% endblock page_title %}</h3>
                            </div>
                            <div class="col-12 col-sm-6 d-flex align-items-center">
                                <div class="d-inline-flex mb-sm-0 mx-auto ml-sm-auto mr-sm-0" role="group" aria-label="Page actions">
                                    {% block header_button %}{% endblock header_button %}
                                </div>
                            </div>
                        </div>
                        <!-- End Page Header -->
                        {% block content %}
                        <div class="error">
                            <div class="error__content">
                              <h2>500</h2>
                              <h3>{% trans "You don't seem to have created a Dashboard Page" %}</h3>
                              <p>{% trans "Press the following button to start." %}</p>
                              <a href="{% url 'admin:dashboard_dashboardpage_add' %}" type="button" class="btn btn-primary btn-pill">{% trans "New page" %}</a>
                            </div> <!-- / .error_content -->
                        </div>
                        {% endblock content %}
                    </div>
                    <footer class="main-footer d-flex p-2 px-3 bg-white border-top">
                        {% show_menu 0 1 100 100 "dashboard/menu.html" %}
                    </footer>
                </main>  
            </div>
        </div>
        
        <script src="{% static 'dashboard/js/jquery.min.js' %}"></script>
        <script src="{% static 'dashboard/js/bootstrap.min.js' %}"></script>
        <script src="{% static 'dashboard/js/Chart.min.js' %}"></script>
        <script src="{% static 'dashboard/js/shards-dashboards.1.3.1.min.js' %}"></script>
        <script type="text/javascript" charset="UTF-8" src="https://www.gstatic.com/charts/48.1/loader.js"></script>
        <script type="text/javascript" charset="UTF-8" src="https://www.gstatic.com/charts/48.1/js/jsapi_compiled_format_module.js"></script>
        <script type="text/javascript" charset="UTF-8" src="https://www.gstatic.com/charts/48.1/js/jsapi_compiled_default_module.js"></script>
        <script type="text/javascript" charset="UTF-8" src="https://www.gstatic.com/charts/48.1/js/jsapi_compiled_ui_module.js"></script>
        <script type="text/javascript" charset="UTF-8" src="https://www.gstatic.com/charts/48.1/js/jsapi_compiled_geochart_module.js"></script>
        {% render_block "js" %}
        {% block script %}{% endblock script %}
        {% analytical_body_bottom %}
    </body>
</html>

dashboard/templates/dashboard/default.html
{% extends "dashboard/base.html" %}
{% load cms_tags i18n %}

{% block page_subtitle %}{% trans "Dashboard" %}{% endblock page_subtitle %}
{% block page_title %}{% trans object.name %}{% endblock page_title %}

{% block dashboard_sidebar %}
{% include "dashboard/includes/sidebar.html" %}
{% endblock dashboard_sidebar %}

{% block dashboard_navbar %}
{% include "dashboard/includes/navbar.html" %}
{% endblock dashboard_navbar %}

{% block content %}
{% render_placeholder object.page %}
{% endblock content %}

dashboard/templates/dashboard/includes/navbar.html
{% load i18n %}

<style>
    ul.navbar-nav  div.dropdown-menu {
        left: 0!important;
    }

    @media (min-width: 768px) { 
        ul.navbar-nav div.dropdown-menu {
            left: auto!important;
        }
    }
</style>

<div class="main-navbar sticky-top bg-white">
    <!-- Main Navbar -->
    <nav class="navbar align-items-stretch navbar-light flex-md-nowrap p-0">
        <div class="w-100 f-flex"></div>
        <ul class="navbar-nav border-left flex-row">
            <li class="nav-item dropdown">
                <a class="nav-link dropdown-toggle text-nowrap px-3 pt-4" data-toggle="dropdown" href="#" role="button" aria-haspopup="true" aria-expanded="false">
                    <span class="d-inline-block">{% if request.user.get_full_name %}{{ request.user.get_full_name }}{% else %}{{ request.user.username }}{% endif %}</span>
                </a>
                <div class="dropdown-menu dropdown-menu-small">
                    <div class="dropdown-divider"></div>
                    <a class="dropdown-item text-danger" href="{% url 'account_logout' %}">
                        <i class="fas fa-sign-out-alt"></i> Logout </a>
                </div>
            </li>
        </ul>
        <nav class="nav">
            <a href="#" class="nav-link nav-link-icon toggle-sidebar d-sm-inline d-md-none text-center border-left" data-toggle="collapse" data-target=".header-navbar" aria-expanded="false" aria-controls="header-navbar">
                <i class="fas fa-bars"></i>
            </a>
        </nav>
    </nav>
</div>
<!-- / .main-navbar -->

dashboard/templates/dashboard/includes/sidebar.html
{% load staticfiles i18n sekizai_tags %}
<!-- Main Sidebar -->
<aside class="main-sidebar col-12 col-md-3 col-lg-2 px-0">
    <div class="main-navbar">
        <nav class="navbar align-items-stretch navbar-light bg-white flex-md-nowrap border-bottom p-0">
            <a class="navbar-brand w-100 mr-0" href="{% url 'dashboard:dashboard-main' %}" style="line-height: 25px;">
                <div class="d-table m-auto">
                    <span class="d-inline ml-1">{% trans "Dashboard" %}</span>
                </div>
            </a>
            <a class="toggle-sidebar d-sm-inline d-md-none d-lg-none">
                <i class="fas fa-chevron-left"></i>
            </a>
        </nav>
    </div>
    <div class="nav-wrapper">
        <h6 class="main-sidebar__nav-title d-flex align-items-center justify-content-between">
            {% trans "Dashboards" %}
            <a href="{% url 'admin:dashboard_dashboardpage_add' %}" class="btn btn-sm btn-default btn-pill d-flex justify-content-end align-items-center">
                <i class="fas fa-plus d-inline-block mr-1"></i> 
                <span class="d-inline d-md-none d-lg-none d-xl-none">{% trans "New page" %}</span>
            </a>
        </h6>
        <ul class="nav nav--no-borders flex-column">
            {% for item in dashboard_sidebar %}
            <li class="nav-item" id="item-{{ item.pk }}">
                <a class="nav-link" href="{% url 'dashboard:dashboard-detail' item.slug %}">
                    {% if item.icon %}<i class="{{ item.icon }}"></i>{% endif %}
                    <span>{% trans item.name %}</span>
                </a>
            </li>
            {% endfor %}
        </ul>
    </div>
</aside>
<!-- End Main Sidebar -->

{% addtoblock "js" %}
<script type="text/javascript">
    $(document).ready(function() {
        $('#item-{{ active_id }}').addClass("active")
    });
</script>
{% endaddtoblock %}

dashboard/templates/dashboard/menu.html
{% load i18n menu_tags cache %}

{% for child in children %}
    <li class="{% if child.ancestor %}ancestor{% endif %}
        {% if child.selected %} active{% endif %}
        {% if child.children %} dropdown{% endif %} nav-item" role="presentation">
        {% if child.children %}
            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">{{ child.get_menu_title }}<span class="caret"></span></a>
            <div class="dropdown-menu" aria-labelledby="navbarDropdown">
                <!-- {% show_menu from_level to_level extra_inactive extra_active template "" "" child %} -->
                {% for subchild in child.children %}
                <a href="{{ subchild.get_absolute_url }}" class="dropdown-item">{{ subchild.get_menu_title }}</a>
                {% endfor %}
            </div>
        {% else %}
            <a class="nav-link" href="{{ child.get_absolute_url }}">{{ child.get_menu_title }}</a>
        {% endif %}
    </li>
    {% if class and forloop.last and not forloop.parentloop %}{% endif %}
{% endfor %}

dashboard/templates/dashboard/plugins/statistics.html
{% load cms_tags %}
<div class="row">
{% for plugin in instance.child_plugin_instances %}
    {% render_plugin plugin %}
{% endfor %}   
</div>

dashboard/templates/dashboard/plugins/users.html
{% load i18n %}
<div class="col-lg-2 col-md-4 col-sm-6 mb-4">
    <div class="stats-small stats-small--1 card card-small">
        <div class="card-body p-0 d-flex">
            <div class="chartjs-size-monitor"
                style="position: absolute; left: 0px; top: 0px; right: 0px; bottom: 0px; overflow: hidden; pointer-events: none; visibility: hidden; z-index: -1;">
                <div class="chartjs-size-monitor-expand"
                    style="position:absolute;left:0;top:0;right:0;bottom:0;overflow:hidden;pointer-events:none;visibility:hidden;z-index:-1;">
                    <div style="position:absolute;width:1000000px;height:1000000px;left:0;top:0"></div>
                </div>
                <div class="chartjs-size-monitor-shrink"
                    style="position:absolute;left:0;top:0;right:0;bottom:0;overflow:hidden;pointer-events:none;visibility:hidden;z-index:-1;">
                    <div style="position:absolute;width:200%;height:200%;left:0; top:0"></div>
                </div>
            </div>
            <div class="d-flex px-3 mx-auto">
                <div class="stats-small__data text-center align-items-center">
                    <h6 class="stats-small__value count m-0">{{ users|length }}</h6>
                    <span class="stats-small__label mb-1 text-uppercase">{% trans "Users" %}</span>
                    <span class="stats-small__percentage stats-small__percentage--increase">{{ users_increase }}%</span>
                </div>
            </div>
            <canvas height="49" class="analytics-overview-stats-small-1 chartjs-render-monitor" width="249"
                style="display: block; width: 249px; height: 49px;"></canvas>
        </div>
    </div>
</div>